Public Class cCodec

    Public Const G711U_TEXT As String = "G711u-Law"
    Public Const G711A_TEXT As String = "G711a-Law"
    Public Const ILBC_TEXT As String = "iLBC"
    Public Const G610_TEXT As String = "GSM6.10"
    Public Const G729_TEXT As String = "G729"

    Private Const VAX_CODEC_GSM610 As Long = 0
    Private Const VAX_CODEC_ILBC As Long = 1
    Private Const VAX_CODEC_G711A As Long = 2
    Private Const VAX_CODEC_G711U As Long = 3
    Private Const VAX_CODEC_G729 As Long = 4

    Public Const TOTAL_SIZE_CODEC As Long = 4

    Function GetCodecNo(ByVal sCodecName As String) As String

        Dim objCodeList() As String = {G610_TEXT, ILBC_TEXT, G711A_TEXT, G711U_TEXT, G729_TEXT}

        Dim nCodeNo As Integer = Array.IndexOf(objCodeList, sCodecName)

        If nCodeNo = -1 Then
            GetCodecNo = ""
        Else
            GetCodecNo = Convert.ToString(nCodeNo)
        End If

    End Function

    Function GetCodecName(ByVal sCodecNo As String) As String

        GetCodecName = ""

        Dim nCodecNo As Integer = Convert.ToInt32(sCodecNo)

        Select Case nCodecNo

            Case VAX_CODEC_G711U
                GetCodecName = G711U_TEXT
            Case VAX_CODEC_G711A
                GetCodecName = G711A_TEXT
            Case VAX_CODEC_ILBC
                GetCodecName = ILBC_TEXT
            Case VAX_CODEC_GSM610
                GetCodecName = G610_TEXT
            Case VAX_CODEC_G729
                GetCodecName = G729_TEXT

        End Select

    End Function

End Class
