#include "StdAfx.h"
#include "CallPickUpMemberList.h"



CCallPickUpMemberDetails::CCallPickUpMemberDetails()
{
}

CCallPickUpMemberDetails::~CCallPickUpMemberDetails()
{
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////  CCALLPICKUPMEMBERLIST  ///////////////////////////////////////////

CCallPickUpMemberList::CCallPickUpMemberList(void)
{
	m_pMemberList = new CMapCallPickUpMemberList();
	m_pMemberList->InitHashTable(20);
}

CCallPickUpMemberList::~CCallPickUpMemberList(void)
{
	DeleteDetailsAll();
	delete m_pMemberList;
}

////////////////////////////////////////////////////////////////////////////////

CCallPickUpMemberDetails* CCallPickUpMemberList::FindCallPickUpMember(LPCTSTR sMemberName)
{
	CCallPickUpMemberDetails* pMemberDetails = NULL;
	
	if(!m_pMemberList->Lookup(GenKey(sMemberName), pMemberDetails))
		return NULL;

	return pMemberDetails;
}

void CCallPickUpMemberList::DeleteDetailsAll()
{
	CCallPickUpMemberDetails* pMemberDetails = NULL;
	CString sKey;

	POSITION pPos = m_pMemberList->GetStartPosition();
	
	while(pPos != NULL)
	{
		m_pMemberList->GetNextAssoc(pPos, sKey, pMemberDetails);
		delete pMemberDetails;
	}

	m_pMemberList->RemoveAll();
}

CString CCallPickUpMemberList::GenKey(LPCTSTR sMemberName)
{
	CString sKey = sMemberName;
	sKey.MakeLower();

	return sKey;
}

////////////////////////////////////////////////////////////////////////////////

BOOL CCallPickUpMemberList::AddMember(LPCTSTR sMemberName)
{
	if(CString(sMemberName).IsEmpty())
		return FALSE;
	
	if(FindCallPickUpMember(sMemberName) != NULL)
		return FALSE;

	CCallPickUpMemberDetails* pMemberDetails = new CCallPickUpMemberDetails();
	pMemberDetails->m_sPickUpMemberName = sMemberName;

	CString sKey = GenKey(sMemberName);

	m_pMemberList->SetAt(sKey, pMemberDetails);

	return TRUE;
}
void CCallPickUpMemberList::RemoveMember(LPCTSTR sMemberName)
{
	CCallPickUpMemberDetails* pMemberDetails = NULL;
	CString sKey = GenKey(sMemberName);

	if(!m_pMemberList->Lookup(sKey, pMemberDetails))
		return;

	delete pMemberDetails;
	m_pMemberList->RemoveKey(sKey);
}

BOOL CCallPickUpMemberList::GetMemberList(CStringList& sMemberList)
{
	POSITION posList =  m_pMemberList->GetStartPosition();

	CString sPickUpMemberName;
	CCallPickUpMemberDetails* pMemberDetails; 

	while(posList != NULL)
	{
		m_pMemberList->GetNextAssoc(posList, sPickUpMemberName, pMemberDetails);
		sMemberList.AddTail(pMemberDetails->m_sPickUpMemberName);
	}

	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////

BOOL CCallPickUpMemberList::IsGroupMember(LPCTSTR sMemberName)
{
	CCallPickUpMemberDetails* pMemberDetails = NULL;
	CString sKey = GenKey(sMemberName);

	m_pMemberList->Lookup(sKey, pMemberDetails);
	if(pMemberDetails == NULL) return FALSE;

	return TRUE;
}