#include "stdafx.h"
#include "QueueList.h"

#include"QueueAgentList.h"


/////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////

CQueueDetails::CQueueDetails()
{
	m_nQueueMusicId = -1;
	m_nQueueDialToneId = -1;
	
	m_nProcessMode = -1;
	m_nProcessType = -1;

	m_pQueueAgentList = new CQueueAgentList();
}

CQueueDetails::~CQueueDetails()
{
	delete m_pQueueAgentList;
}

BOOL CQueueDetails::AddQueueAgent(LPCTSTR sAgentName)
{
	return m_pQueueAgentList->AddAgent(sAgentName);
}

BOOL CQueueDetails::IsAgentExist(LPCTSTR sAgentName)
{
	return m_pQueueAgentList->IsAgentExist(sAgentName);
}

BOOL CQueueDetails::GetQueueAgentList(CStringList& sListAgentName)
{
	for(int nIndex = 0; nIndex < m_pQueueAgentList->GetQueueAgentCount(); nIndex++)
	{
		sListAgentName.AddTail(m_pQueueAgentList->GetQueueAgentAt(nIndex));
	}

	return TRUE;
}

void CQueueDetails::RemoveQueueAgent(LPCTSTR sAgentName)
{
	m_pQueueAgentList->RemoveAgent(sAgentName);
}


///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

CString CQueueDetails::GetQueueAgentAt(int nIndex)
{
	return m_pQueueAgentList->GetQueueAgentAt(nIndex);
}

int CQueueDetails::GetQueueAgentCount()
{
	return m_pQueueAgentList->GetQueueAgentCount();
}


///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

CQueueList::CQueueList(void)
{
}


CQueueList::~CQueueList(void)
{
	void DeleteQueueAll();
}

void CQueueList::DeleteQueueAll()
{
	POSITION posQueueList = m_objQueueDetailsList.GetStartPosition();
	
	CQueueDetails* pQueueDetails = NULL;
	CString sQueueName;

	while(posQueueList != NULL)
	{
		m_objQueueDetailsList.GetNextAssoc(posQueueList, sQueueName, pQueueDetails);

		if(pQueueDetails != NULL)
			delete pQueueDetails;
	}

	m_objQueueDetailsList.RemoveAll();
}

BOOL CQueueList::AddQueue(LPCTSTR sQueueName, LPCTSTR sQueueMusicFile, int nQueueMusicId, LPCTSTR sQueueDialToneFile, int nQueueDialToneId)
{
	CQueueDetails* pQueueDetails = NULL;

	m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails);

	if(pQueueDetails == NULL)
	{
		pQueueDetails = new CQueueDetails();
		m_objQueueDetailsList.SetAt(sQueueName, pQueueDetails);
	}

	pQueueDetails->m_sQueueName = sQueueMusicFile;
	
	pQueueDetails->m_sQueueMusicFile = sQueueMusicFile;
	pQueueDetails->m_sQueueDialToneFile = sQueueDialToneFile;

	pQueueDetails->m_nQueueMusicId = nQueueMusicId;
	pQueueDetails->m_nQueueDialToneId = nQueueDialToneId;

	return TRUE;
}

void CQueueList::RemoveQueue(LPCTSTR sQueueName)
{
	CQueueDetails* pQueueDetails = NULL;

	m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails);

	if(pQueueDetails == NULL)
		return;

	m_objQueueDetailsList.RemoveKey(sQueueName);

	delete pQueueDetails;

}

int CQueueList::GetQueueMusicId(LPCTSTR sQueueName)
{
	CQueueDetails* pQueueDetails = NULL;
	m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails);

	if(pQueueDetails == NULL)
		return -1;
	
	return pQueueDetails->m_nQueueMusicId;
}

int CQueueList::GetQueueDialToneId(LPCTSTR sQueueName)
{
	CQueueDetails* pQueueDetails = NULL;
	m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails);

	if(pQueueDetails == NULL)
		return -1;
	
	return pQueueDetails->m_nQueueDialToneId;
}

BOOL CQueueList::AddQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName)
{
	CQueueDetails* pQueueDetails = NULL;
	m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails);

	if(pQueueDetails == NULL)
		return FALSE;

	return pQueueDetails->AddQueueAgent(sAgentName);
}

void CQueueList::RemoveQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName)
{
	CQueueDetails* pQueueDetails = NULL;

	m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails);
	if(pQueueDetails == NULL) return;

	pQueueDetails->RemoveQueueAgent(sAgentName);
}

BOOL CQueueList::IsAgentExisted(LPCTSTR sQueueName, LPCTSTR sAgentName)
{
	CQueueDetails* pQueueDetails = NULL;

	m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails);
	if(pQueueDetails == NULL) return FALSE;

	return pQueueDetails->IsAgentExist(sAgentName);
}

BOOL CQueueList::GetQueueNameList(CStringList& sListQueueName)
{
	POSITION posList =  m_objQueueDetailsList.GetStartPosition();
	
	CString sQueueName;
	CQueueDetails* pDetails;

	while(posList != NULL)
	{
		m_objQueueDetailsList.GetNextAssoc(posList, sQueueName, pDetails);
		sListQueueName.AddTail(sQueueName);
	}

	return TRUE;
}

void CQueueList::SetQueueProcessMode(LPCTSTR sQueueName, int nProcessMode, int nProcessType)
{
	CQueueDetails* pQueueDetails = NULL;

	m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails);
	if(pQueueDetails == NULL) return;
		
	pQueueDetails->m_nProcessMode  = nProcessMode;
	pQueueDetails->m_nProcessType = nProcessType;
}

BOOL CQueueList::GetQueueDetails(LPCTSTR sQueueName, int& nProcessMode, int& nProcessType, CStringList& sListQueueAgent, CString& sQueueMusicFile, CString& sQueueDialToneFile)
{
	CQueueDetails* pQueueDetails = NULL;

	if(!m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails))
		return FALSE;
		
	nProcessMode = pQueueDetails->m_nProcessMode;
	nProcessType = pQueueDetails->m_nProcessType;

	sQueueMusicFile = pQueueDetails->m_sQueueMusicFile;
	sQueueDialToneFile = pQueueDetails->m_sQueueDialToneFile;

	return pQueueDetails->GetQueueAgentList(sListQueueAgent);
}

CString CQueueList::GetQueueAgentAt(LPCTSTR sQueueName, int nIndex)
{
	CQueueDetails* pQueueDetails = NULL;

	m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails);
	if(pQueueDetails == NULL) return "";

	return pQueueDetails->GetQueueAgentAt(nIndex);
}

int CQueueList::GetQueueAgentCount(LPCTSTR sQueueName)
{
	CQueueDetails* pQueueDetails = NULL;

	m_objQueueDetailsList.Lookup(sQueueName, pQueueDetails);
	if(pQueueDetails == NULL) return FALSE;

	return pQueueDetails->GetQueueAgentCount();
}
