﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cStoreQueue : cStoreRegistry
    {
        const string QUEUE_ROOT_PATH = "Queues\\";

        public cStoreQueue()
        {
        }

        ~cStoreQueue()
        {
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool AddQueue(string sQueueName)
        {
            if(sQueueName.Length == 0)
                return false;

            string skeyPath = QUEUE_ROOT_PATH + sQueueName;
            base.SetTEXT(skeyPath, "QueueName", sQueueName);

            return true;
        }

        public bool RemoveQueue(string sQueueName)
        {
            if(sQueueName.Length == 0)
                return false;

            string skeyPath = QUEUE_ROOT_PATH + sQueueName;
            return base.DeleteSubKey(skeyPath);
        }

        public bool GetQueueNameAll(ref List<string> objListQueueName)
        {
            objListQueueName.Clear();

            string sKeyPath = QUEUE_ROOT_PATH;
            return base.EnumSubKeys(sKeyPath, ref objListQueueName);
        }

        public bool SetMusicFile(string sQueueName, string sFileName)
        {
            string sPath = QUEUE_ROOT_PATH + sQueueName;
            
            base.SetTEXT(sPath, "MusicFileName", sFileName);
            return true;
        }

        public bool GetMusicFile(string sQueueName, ref string sFileName)
        {
            string sPath = QUEUE_ROOT_PATH + sQueueName;
            return base.GetTEXT(sPath, "MusicFileName", ref sFileName);                
        }
        
        public bool SetDialToneFile(string sQueueName, string sFileName)
        {
            string sPath = QUEUE_ROOT_PATH + sQueueName;

            base.SetTEXT(sPath, "DialToneFileName", sFileName);
            return true;
        }

        public bool GetDialToneFile(string sQueueName, ref string sFileName)
        {
            string sPath = QUEUE_ROOT_PATH + sQueueName;
            return base.GetTEXT(sPath, "DialToneFileName", ref sFileName);
        }
        
        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool SetQueueProcessMode(string sQueueName, int nModeId, int nModeType)
        {
            if(sQueueName.Length == 0)
                return false;

            string skeyPath = QUEUE_ROOT_PATH + sQueueName;

            base.SetINT(skeyPath, "ProcessMode", nModeId);
            base.SetINT(skeyPath, "ProcessType", nModeType);

            return true;
        }

        public bool GetQueueProcessMode(string sQueueName, ref int nModeId, ref int nModeType)
        {
            if(sQueueName.Length == 0)
                return false;

            string skeyPath = QUEUE_ROOT_PATH + sQueueName;

            base.GetINT(skeyPath, "ProcessMode", ref nModeId);
            base.GetINT(skeyPath, "ProcessType", ref nModeType);

            return true;
        }
        
        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////
        
        public bool AddQueueAgent(string sQueueName, string sUserName)
        {
            if(sQueueName.Length == 0)
                return false;

            string skeyPath = QUEUE_ROOT_PATH + sQueueName + "\\" + sUserName;
            return base.SetTEXT(skeyPath, "UserName", sUserName);
        }

        public bool RemoveQueueAgent(string sQueueName, string sUserName)
        {
            if(sQueueName.Length == 0)
                return false;

            string skeyPath = QUEUE_ROOT_PATH + sQueueName + "\\" + sUserName;
            return base.DeleteSubKey(skeyPath);
        }

        public bool GetQueueAgentNameAll(string sQueueName, ref List<string> objListQueueAgentName)
        {
            objListQueueAgentName.Clear();

            string sKeyPath = QUEUE_ROOT_PATH + sQueueName;
            return base.EnumSubKeys(sKeyPath, ref objListQueueAgentName);
        }
        
        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public bool SetQueueAgentPriority(string sQueueName, string sUserName, int nPriority)
        {
            if(sQueueName.Length == 0)
                return false;

            string skeyPath = QUEUE_ROOT_PATH + sQueueName + "\\" + sUserName;
            return base.SetINT(skeyPath, "Priority", nPriority);
        }

        public bool GetQueueAgentPriority(string sQueueName, string sUserName, ref int nPriority)
        {
            if(sQueueName.Length == 0)
                return false;

            string skeyPath = QUEUE_ROOT_PATH + sQueueName + "\\" + sUserName;
            return base.GetINT(skeyPath, "Priority", ref nPriority);
        }

        public bool IsDataStored()
        {
            return base.IsKeyExist(QUEUE_ROOT_PATH);
        }

    }
}
