unit SIPRecDlg;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VaxServerExCOM, Vcl.StdCtrls, Vcl.ComCtrls;

type
  TSIPRecForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditAuthLogin: TEdit;
    EditAuthPwd: TEdit;
    EditSIPProxy: TEdit;
    CheckBoxSIPServerREC: TCheckBox;
    BtnOnline: TButton;
    GroupBox2: TGroupBox;
    ListStatus: TListBox;
    btnCLearStatus: TButton;
    procedure BtnOnlineClick(Sender: TObject);
    procedure btnCLearStatusClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    constructor Create(AOwner: TComponent); reintroduce; overload;
    procedure OnSetActive();

     procedure OnLineRegisterTryingREC( sLineName : string);
     procedure OnLineRegisterFailedREC( sLineName : string; nStatusCode : integer;  sReasonPhrase : string);
     procedure OnLineRegisterSuccessREC( sLineName : string);
     procedure OnLineUnRegisterTryingREC( sLineName : string);
     procedure OnLineUnRegisterFailedREC( sLineName : string; nStatusCode : integer;  sReasonPhrase : string);
     procedure OnLineUnRegisterSuccessREC( sLineName : string);

     procedure OnServerConnectingREC(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String);
     procedure OnServerConnectedREC(nSessionId: Integer; nChannelId: Integer);
     procedure OnServerFailedREC(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String);
     procedure OnServerTimeoutREC(nSessionId: Integer; nChannelId: Integer);
     procedure OnServerHungupREC(nSessionId: Integer; nChannelId: Integer);

     procedure OnStatusLog(sStatus : WideString);

  end;

var
  SIPRecForm: TSIPRecForm;

implementation

{$R *.dfm}

constructor TSIPRECForm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

procedure TSIPRECForm.OnSetActive();
begin
  //
end;

procedure TSIPRecForm.BtnOnlineClick(Sender: TObject);
var
sStatus : WideString;
begin

  if (Length(EditAuthLogin.Text) = 0) or (Length(EditSIPProxy.Text) = 0) then
    Exit;

  if BtnOnline.Caption = 'Offline' Then
  begin

    BtnOnline.Caption := 'Online';
    TVaxServerExCOM.mVaxExCOM.DeactivateREC();
    Exit;

  end;

  BtnOnline.Caption := 'Offline';
  TVaxServerExCOM.mVaxExCOM.ActivateREC(EditAuthLogin.Text, EditAuthPwd.Text, EditSIPProxy.Text, CheckBoxSIPServerREC.Checked);

  if CheckBoxSIPServerREC.Checked = False then
  begin

   sStatus := 'Account is online';
   OnStatusLog(sStatus);

  end;

end;

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

procedure TSIPRecForm.OnLineRegisterTryingREC(sLineName: string);
var
sStatus : WideString;
begin
     sStatus := sLineName + ': Trying to register';
     OnStatusLog(sStatus);
end;

procedure TSIPRecForm.OnLineRegisterFailedREC(sLineName: string; nStatusCode: Integer; sReasonPhrase: string);
var
sStatus : WideString;
begin
     sStatus := sLineName + ': Failed to register (' + sReasonPhrase + ')';
     OnStatusLog(sStatus);
end;

procedure TSIPRecForm.OnLineRegisterSuccessREC(sLineName: string);
var
sStatus :string;
begin
    sStatus := sLineName + ': Registered successfully';
    OnStatusLog(sStatus);
end;

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

procedure TSIPRecForm.OnLineUnRegisterTryingREC(sLineName: string);
var
sStatus : WideString;
begin
     sStatus := sLineName + ': Trying to unregister';
     OnStatusLog(sStatus);
end;

procedure TSIPRecForm.OnLineUnRegisterFailedREC(sLineName: string; nStatusCode: Integer; sReasonPhrase: string);
var
sStatus : WideString;
begin
     sStatus := sLineName + ': Failed to unregister (' + sReasonPhrase + ')';
     OnStatusLog(sStatus);
end;

procedure TSIPRecForm.OnLineUnRegisterSuccessREC(sLineName: string);
var
sStatus :string;
begin
  sStatus := sLineName + ': Unregistered successfully';
  OnStatusLog(sStatus);
end;

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

procedure TSIPRecForm.OnServerConnectingREC(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String);
var
sStatus :string;
begin
  sStatus := 'Session: ' + inttostr(nSessionId) + ' trying to connect';
  OnStatusLog(sStatus);
end;

procedure TSIPRecForm.OnServerConnectedREC(nSessionId: Integer; nChannelId: Integer);
var
sStatus :string;
begin
  sStatus := 'Session: ' + inttostr(nSessionId) + ' connected successfully';
  OnStatusLog(sStatus);
end;

procedure TSIPRecForm.OnServerFailedREC(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String);
var
sStatus :string;
begin
  sStatus := 'Session: ' + inttostr(nSessionId) + ' failed to connect' + ' (' + sReasonPhrase + ')';
  OnStatusLog(sStatus);
end;

procedure TSIPRecForm.OnServerTimeoutREC(nSessionId: Integer; nChannelId: Integer);
var
sStatus :string;
begin
  sStatus := 'Session: ' + inttostr(nSessionId) + ' failed to connect (timeout)';
  OnStatusLog(sStatus);
end;

procedure TSIPRecForm.OnServerHungupREC(nSessionId: Integer; nChannelId: Integer);
var
sStatus :string;
begin
  sStatus := 'Session: ' + inttostr(nSessionId) + ' Hungup';
  OnStatusLog(sStatus);
end;

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

procedure TSIPRecForm.btnClearStatusClick(Sender: TObject);
var
tabStatusLogSheet : TTabSheet;
begin
     ListStatus.Clear();

     tabStatusLogSheet := TTabSheet(Self.Parent);
     tabStatusLogSheet.Caption := 'SIP REC';
end;

procedure TSIPRecForm.OnStatuslog(sStatus: WideString);
var
nTotalCount : Integer;
tabStatusLogSheet : TTabSheet;
begin
  ListStatus.Items.Add(sStatus);

  nTotalCount := ListStatus.Items.Count;

  tabStatusLogSheet := TTabSheet(Self.Parent);
  tabStatusLogSheet.Caption := 'SIP REC (' + IntToStr(nTotalCount) + ')';
end;

end.
