#include "stdafx.h"

#include "VaxServerExSIP.h"

#include "StatusLogDlg.h"
#include "ErrorLogDlg.h"

#include "CPU.h"
#include "GenStatus.h"

CVaxServerExSIP::CVaxServerExSIP(void)
{
}

CVaxServerExSIP::~CVaxServerExSIP(void)
{
}

BOOL CVaxServerExSIP::StartServer(LPCTSTR sDomainRealm, LPCTSTR sListenIP, int nListenPort)
{
	return CVaxServerSIP::Initialize(sDomainRealm, sListenIP, nListenPort, sListenIP, -1);
}
void CVaxServerExSIP::StopServer()
{
	CVaxServerSIP::UnInitialize();

	TRACE("Server UnInitialized Succesfully.\n");
}

int CVaxServerExSIP::GetCallCount()
{
	return 0;
}
int CVaxServerExSIP::GetUserCount()
{
	return 0;
}

DWORD CVaxServerExSIP::GetUsageCPU()
{
	CPU objCPU;
	return objCPU.GetUsageCPU();
}
DWORD CVaxServerExSIP::GetAvailMEM()
{
	MEMORYSTATUSEX statex;
	statex.dwLength = sizeof (statex);

	GlobalMemoryStatusEx (&statex);	// memory retrieved in bytes

	return (DWORD) statex.ullAvailPhys / (1024 * 1024);	// return in the form of mega bytes.
}

void CVaxServerExSIP::OnStatusLog(LPCTSTR sStatus)
{
	m_pStatusLogDlg->OnStatusLog(sStatus);
}
void CVaxServerExSIP::OnErrorLog(LPCTSTR sErrorMsg)
{
	m_pErrorLogDlg->OnErrorLog(sErrorMsg);
}

BOOL CVaxServerExSIP::AddUserToLineRoute(CString sUserName, LPCTSTR sUserPrefix, int nConnectType, LPCTSTR sConnectName, LPCTSTR sDialPrefix)
{
	return CVaxServerSIP::AddUserToLineRoute(sUserName, sUserPrefix, nConnectType, sConnectName, sDialPrefix);
}
BOOL CVaxServerExSIP::AddUserToDirectProxyRoute(CString sUserName, LPCTSTR sUserPrefix, int nConnectType, LPCTSTR sConnectName, LPCTSTR sDialPrefix)
{
	return CVaxServerSIP::AddUserToDirectProxyRoute(sUserName, sUserPrefix, nConnectType, sConnectName, sDialPrefix);
}

BOOL CVaxServerExSIP::AddLineToUserRoute(CString sLineName, int nConnectType, LPCTSTR sConnectName)
{
	return CVaxServerSIP::AddLineToUserRoute(sLineName, nConnectType, sConnectName);
}
BOOL CVaxServerExSIP::AddLineToLineRoute(CString sLineName, int nConnectType, LPCTSTR sConnectName)
{
	return CVaxServerSIP::AddLineToLineRoute(sLineName, nConnectType, sConnectName);
}
BOOL CVaxServerExSIP::AddLineToDirectProxyRoute(CString sLineName, int nConnectType, LPCTSTR sConnectName)
{
	return CVaxServerSIP::AddLineToDirectProxyRoute(sLineName, nConnectType, sConnectName);
}
BOOL CVaxServerExSIP::AddLineToQueueRoute(CString sLineName, int nConnectType, LPCTSTR sConnectName)
{
	return CVaxServerSIP::AddLineToQueueRoute(sLineName, nConnectType, sConnectName);
}
BOOL CVaxServerExSIP::AddLineRejectRoute(CString sLineName, int nConnectType, LPCTSTR sConnectName)
{
	return CVaxServerSIP::AddLineRejectRoute(sLineName, nConnectType, sConnectName);
}

BOOL CVaxServerExSIP::AddDirectProxyToUserRoute(CString sDirectProxySIP, int nCallToType, LPCTSTR sDialNo)
{
	return CVaxServerSIP::AddDirectProxyToUserRoute(sDirectProxySIP, nCallToType, sDialNo);
}
BOOL CVaxServerExSIP::AddDirectProxyToLineRoute(CString sDirectProxySIP, int nCallToType, LPCTSTR sDialNo)
{
	return CVaxServerSIP::AddDirectProxyToLineRoute(sDirectProxySIP, nCallToType, sDialNo);
}
BOOL CVaxServerExSIP::AddDirectProxyToDirectProxyRoute(CString sDirectProxySIP, int nCallToType, LPCTSTR sDialNo)
{
	return CVaxServerSIP::AddDirectProxyToDirectProxyRoute(sDirectProxySIP, nCallToType, sDialNo);
}
BOOL CVaxServerExSIP::AddDirectProxyToQueueRoute(CString sDirectProxySIP, int nCallToType, LPCTSTR sDialNo)
{
	return CVaxServerSIP::AddDirectProxyToQueueRoute(sDirectProxySIP, nCallToType, sDialNo);
}
BOOL CVaxServerExSIP::AddDirectProxyRejectRoute(CString sDirectProxySIP, int nCallToType, LPCTSTR sDialNo)
{
	return CVaxServerSIP::AddDirectProxyRejectRoute(sDirectProxySIP, nCallToType, sDialNo);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////
//					Virtual Functions
////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CVaxServerExSIP::OnUnRegisterUser(LPCTSTR sUserLogin)
{
	CVaxServerSIP::RemoveUser(sUserLogin);
}
void CVaxServerExSIP::OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sFromIP, LONG lFromPort)
{
	CRegistry objReg;
	CUserReg objLoginReg;

	if(!objReg.GetUser(sUserLogin, &objLoginReg))
	{
		CVaxServerSIP::RejectRegister(sUserLogin);
		return;
	}

	if(objLoginReg.m_bBlock)
	{
		CVaxServerSIP::RejectRegister(sUserLogin);
		return;
	}

	CVaxServerSIP::AddUser(sUserLogin, objLoginReg.m_sPassword, objLoginReg.m_sCodec, objLoginReg.m_bStealth);

	BOOL bResult = CVaxServerSIP::AuthRegister(sUserLogin);
	if(bResult)
	{
		CUserStatus objUserStatus;
		CString sStatus = objUserStatus.GenTryingToReg(sUserLogin);  // get formatted status with sLineName

		OnStatusLog(sStatus);
	}
}
void CVaxServerExSIP::OnRegisterUserSuccess(LPCTSTR sUserLogin)
{
	CRegistry objReg;
	CUserReg objUserReg;

	if(!objReg.GetUser(sUserLogin, &objUserReg))
	{
		CVaxServerSIP::RejectRegister(sUserLogin);
		return;
	}

	if(objUserReg.m_bBlock)
	{
		CVaxServerSIP::RejectRegister(sUserLogin);
		return;
	}

	CUserStatus objUserStatus;
	CString sStatus = objUserStatus.GenSuccessToReg(sUserLogin);  // get formatted status with sLineName
	OnStatusLog(sStatus);

	CString sUserName = sUserLogin;
	if(sUserName == "9999") return;

	// add the USER-ROUTE for this particular USER

	if(objUserReg.m_sConnectName.IsEmpty()) return;

	if(atoi(objUserReg.m_sConnectType) == ROUTE_CONNECT_TYPE_LINE)
		CVaxServerSIP::AddUserToLineRoute(sUserLogin, objUserReg.m_sUserPrefix, ROUTE_CONNECT_TYPE_LINE, objUserReg.m_sConnectName, objUserReg.m_sDialPrefix);
	else if(atoi(objUserReg.m_sConnectType) == ROUTE_CONNECT_TYPE_DIRECT_PROXY)
		CVaxServerSIP::AddUserToDirectProxyRoute(sUserLogin, objUserReg.m_sUserPrefix, ROUTE_CONNECT_TYPE_DIRECT_PROXY, objUserReg.m_sConnectName, objUserReg.m_sDialPrefix);

}
void CVaxServerExSIP::OnRegisterUserFail(LPCTSTR sUserLogin)
{
	CUserStatus objUserStatus;
	CString sStatus = objUserStatus.GenFailToReg(sUserLogin);  // get formatted status with sLineName

	OnStatusLog(sStatus);
}

void CVaxServerExSIP::OnLineRegisterTrying(LPCTSTR sLineName)
{
	CLineStatus objLineStatus;
	CString sStatus = objLineStatus.GenTryingToRegStatus(sLineName);  // get formatted status with sLineName

	OnStatusLog(sStatus);
}
void CVaxServerExSIP::OnLineRegisterFail(LPCTSTR sLineName, long lStatusCode, LPCTSTR sReasonPhrase)
{
	CLineStatus objLineStatus;
	CString sStatus = objLineStatus.GenFailToRegStatus(sLineName);  // get formatted status with sLineName

	OnStatusLog(sStatus);
}
void CVaxServerExSIP::OnLineRegisterSuccess(LPCTSTR sLineName)
{
	CLineStatus objLineStatus;
	CString sStatus = objLineStatus.GenSuccessToRegStatus(sLineName);  // get formatted status with sLineName

	OnStatusLog(sStatus);
}
void CVaxServerExSIP::OnLineUnRegisterTrying(LPCTSTR sLineName)
{
	CLineStatus objLineStatus;
	CString sStatus = objLineStatus.GenTryingToUnRegStatus(sLineName);  // get formatted status with sLineName

	OnStatusLog(sStatus);
}
void CVaxServerExSIP::OnLineUnRegisterFail(LPCTSTR sLineName)
{
	CLineStatus objLineStatus;
	CString sStatus = objLineStatus.GenFailToUnRegStatus(sLineName);  // get formatted status with sLineName

	OnStatusLog(sStatus);
}
void CVaxServerExSIP::OnLineUnRegisterSuccess(LPCTSTR sLineName)
{
	CLineStatus objLineStatus;
	CString sStatus = objLineStatus.GenSuccessToUnRegStatus(sLineName);  // get formatted status with sLineName

	OnStatusLog(sStatus);
}


//void CVaxServerExSIP::ShowUsers(CStringList* pUserList)
//{
//	CRegistry objReg;
//	objReg.EnumUser(pUserList);
//}
//BOOL CVaxServerExSIP::UserInfo(LPCTSTR sLogin, CString& sPassword, CString& sCodecList, CString& sDialPrefix, CString& sUserPrefix, CString& sConnectName, BOOL& bStealth, BOOL& bBlock)
//{
//	CRegistry objReg;
//	CUserReg objLoginReg;
//		
//	if(!objReg.GetUser(sLogin, &objLoginReg))
//	{
//		OnErrorLog("Login not found.");
//		return FALSE;
//	}
//		
//	sPassword = objLoginReg.m_sPassword;
//	sCodecList = objLoginReg.m_sCodec;
//	
//	bStealth = objLoginReg.m_bStealth;
//	bBlock = objLoginReg.m_bBlock;
//
//	sDialPrefix = objLoginReg.m_sDialPrefix;
//	sUserPrefix = objLoginReg.m_sUserPrefix;
//	sConnectName = objLoginReg.m_sConnectName;
//
//	return TRUE;
//}
//BOOL CVaxServerExSIP::AddUser(LPCTSTR sLogin, LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bStealth, BOOL bBlock, LPCTSTR sDialPrefix, LPCTSTR sCallPrefix, LPCTSTR sConnectName, DWORD dwRouteType, BOOL& bUpdated)
//{
//	CRegistry objReg;
//	CUserReg objUserReg;
//	
//	objUserReg.m_sPassword = sPassword;
//	objUserReg.m_sCodec    = sCodecList;
//	
//	objUserReg.m_bStealth  = bStealth;
//	objUserReg.m_bBlock    = bBlock;
//
//	objUserReg.m_sDialPrefix = sDialPrefix;
//	objUserReg.m_sUserPrefix = sCallPrefix; // NOTE:		m_sCallPrefix = UserPrefix (i.e. this is the PREFIX that will be replaced by DIAL_PREFIX)
//	
//	if(objUserReg.m_sDialPrefix.IsEmpty() && objUserReg.m_sUserPrefix.IsEmpty())
//		objUserReg.m_sConnectName = "";
//	else
//		objUserReg.m_sConnectName = sConnectName;
//		
//	if(dwRouteType == ROUTE_CONNECT_TYPE_LINE)
//		objUserReg.m_sConnectType.Format("%d", ROUTE_CONNECT_TYPE_LINE);
//	else
//		objUserReg.m_sConnectType.Format("%d", ROUTE_CONNECT_TYPE_DIRECT_PROXY);
//
//	bUpdated = objReg.IsUserExist(sLogin);
//	
//	if(!objReg.SetUser(sLogin, &objUserReg))
//	{
//		OnErrorLog("Unable to add user.");
//		return FALSE;
//	}
//
//	if(dwRouteType == ROUTE_CONNECT_TYPE_LINE)
//		CVaxServerSIP::AddUserToLineRoute(sLogin, sCallPrefix, ROUTE_CONNECT_TYPE_LINE, sConnectName, sDialPrefix);
//	else if(dwRouteType == ROUTE_CONNECT_TYPE_DIRECT_PROXY)
//		CVaxServerSIP::AddUserToDirectProxyRoute(sLogin, sCallPrefix, ROUTE_CONNECT_TYPE_DIRECT_PROXY, sConnectName, sDialPrefix);
//
//
//	return TRUE;
//}
//BOOL CVaxServerExSIP::RemoveUser(LPCTSTR sLogin)
//{
//	CRegistry objReg;
//	if(!objReg.RemoveUser(sLogin))
//	{
//		OnErrorLog("Unable to remove user.");
//		return FALSE;
//	}
//
//	CVaxServerSIP::RemoveUser(sLogin);
//
//	return TRUE;
//}
//
//void CVaxServerExSIP::ShowLines(CStringList* pLineList)
//{
//	CRegistry objReg;
//	objReg.EnumLine(pLineList);
//}
//BOOL CVaxServerExSIP::LineInfo(LPCTSTR sLineName, CString& sCodecList, CString& sDisplayName, CString& sUserName, CString& sAuthUser, CString& sAuthPwd, CString& sDomainRealm, CString& sProxySIP, CString& sOutboundProxy, BOOL& bIsRegister, DWORD& dwInCallType, CString& sInCallTo)
//{
//	CRegistry objReg;
//	CLineReg objLineReg;
//	
//	if(!objReg.GetLine(sLineName, &objLineReg))
//	{
//		OnErrorLog("Line not found.");
//		return FALSE;
//	}
//	
//	sDisplayName = objLineReg.m_sDisplayName;
//	sUserName = objLineReg.m_sUserName;
//	sAuthUser = objLineReg.m_sAuthUser;
//	sAuthPwd = objLineReg.m_sPassword;
//	sDomainRealm = objLineReg.m_sRealm;
//	sProxySIP = objLineReg.m_sProxy;
//	sOutboundProxy = objLineReg.m_sOutboundProxy;
//	sCodecList = objLineReg.m_sCodec;
//
//	bIsRegister = objLineReg.m_bRegister;
//	
//	sInCallTo = objLineReg.m_sInCallTo;
//	dwInCallType = objLineReg.m_dwInCallType;
//
//	return TRUE;
//}
//BOOL CVaxServerExSIP::AddLine(LPCTSTR sLineName, LPCTSTR sCodecList, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sOutboundProxy, BOOL bRegister, DWORD dwInCallType, LPCTSTR sInCallTo,BOOL& bUpdated)
//{
//	CRegistry objReg;
//	CLineReg objLineReg;
//
//	objLineReg.m_sDisplayName = sDisplayName;
//    objLineReg.m_sUserName = sUserName;
//    objLineReg.m_sAuthUser = sAuthUser;
//    objLineReg.m_sPassword = sAuthPwd;
//    objLineReg.m_sRealm = sDomainRealm;
//    objLineReg.m_sProxy = sProxySIP;
//    objLineReg.m_sOutboundProxy = sOutboundProxy;
//    
//	objLineReg.m_bRegister = bRegister;
//	objLineReg.m_dwInCallType = dwInCallType;
//
//    objLineReg.m_sInCallTo = sInCallTo;
//	objLineReg.m_sCodec = sCodecList;
//
//	bUpdated = objReg.IsLineExist(sLineName);
//
//	if(!objReg.SetLine(sLineName, &objLineReg))
//	{
//		OnErrorLog("Unable to add line.");
//		return FALSE;
//	}
//	
//	CVaxServerSIP::RemoveLine(sLineName);
//
//	CVaxServerSIP::AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxy, sCodecList, bRegister);
//	if(bRegister == TRUE)
//	{
//		CVaxServerSIP::RegisterLine(sLineName);
//	}
//
//	if(dwInCallType == ROUTE_CONNECT_TYPE_USER)
//		CVaxServerSIP::AddLineToUserRoute(sLineName, ROUTE_CONNECT_TYPE_USER, sInCallTo);
//	else if(dwInCallType == ROUTE_CONNECT_TYPE_QUEUE)
//		CVaxServerSIP::AddLineToQueueRoute(sLineName, ROUTE_CONNECT_TYPE_QUEUE, sInCallTo);
//	else if(dwInCallType == ROUTE_CONNECT_TYPE_REJECT)
//		CVaxServerSIP::AddLineRejectRoute(sLineName, ROUTE_CONNECT_TYPE_REJECT, sInCallTo);
//
//	return TRUE;
//}
//BOOL CVaxServerExSIP::RemoveLine(LPCTSTR sLineName)
//{
//	CRegistry objReg;
//	
//	if(objReg.IsLineExist(sLineName))
//		objReg.RemoveLine(sLineName);
//
//	CVaxServerSIP::RemoveLine(sLineName);
//	
//	return TRUE;
//}
//
//void CVaxServerExSIP::ShowDirectProxies(CStringList* pProxyList)
//{
//	CRegistry objReg;
//	objReg.EnumProxy(pProxyList);
//}
//BOOL CVaxServerExSIP::DirectProxyInfo(LPCTSTR sProxyName, CString& sCodecList, CString& sAuthUser, CString& sAuthPwd, CString& sDomainRealm, CString& sProxySIP, DWORD& dwProxyPort, DWORD& dwInCallType, CString& sInCallTo)
//{
//	CRegistry objReg;
//	CProxyReg objProxyReg;
//
//	if(!objReg.GetProxy(sProxyName, &objProxyReg))
//	{
//		OnErrorLog("Proxy not found.");
//		return FALSE;
//	}
//	
//	sAuthUser = objProxyReg.m_sAuthUser;
//	sAuthPwd = objProxyReg.m_sPassword;
//	
//	sDomainRealm = objProxyReg.m_sRealm;
//	sProxySIP = objProxyReg.m_sProxy;
//	
//	sCodecList = objProxyReg.m_sCodec;
//	dwProxyPort = objProxyReg.m_dwPort;
//	
//	dwInCallType = objProxyReg.m_dwInCallType;
//	sInCallTo = objProxyReg.m_sInCallTo;
//	
//	return TRUE;
//}
//BOOL CVaxServerExSIP::AddDirectProxy(LPCTSTR sProxyName, LPCTSTR sCodecList, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, DWORD dwProxyPort, DWORD dwInCallType, LPCTSTR sInCallTo, BOOL& bUpdated)
//{
//	CRegistry objReg;
//	CProxyReg objProxyReg;
//
//    objProxyReg.m_sAuthUser = sAuthUser;
//    objProxyReg.m_sPassword = sAuthPwd;
//    
//	objProxyReg.m_sRealm = sDomainRealm;
//    objProxyReg.m_sProxy = sProxySIP;
//
//	objProxyReg.m_dwPort = dwProxyPort;
//	objProxyReg.m_dwInCallType = dwInCallType;
//    
//	objProxyReg.m_sInCallTo = sInCallTo;
//	objProxyReg.m_sCodec = sCodecList;
//
//	bUpdated = objReg.IsProxyExist(sProxyName);
//
//	if(!objReg.SetProxy(sProxyName, &objProxyReg))
//	{
//		OnErrorLog("Unable to add proxy.");
//		CVaxServerSIP::RemoveDirectProxySIP(sProxyName);
//
//		return FALSE;
//	}
//
//	BOOL bResult = CVaxServerSIP::AddDirectProxySIP(sProxyName, sAuthUser, sAuthPwd, sProxySIP, sDomainRealm, sCodecList, dwProxyPort);
//	if(!bResult) return false;
//
//
//	if(dwInCallType == ROUTE_CONNECT_TYPE_USER)
//		CVaxServerSIP::AddDirectProxyToUserRoute(sProxyName, ROUTE_CONNECT_TYPE_USER, sInCallTo);
//	else if(dwInCallType == ROUTE_CONNECT_TYPE_QUEUE)
//		CVaxServerSIP::AddDirectProxyToQueueRoute(sProxyName, ROUTE_CONNECT_TYPE_QUEUE, sInCallTo);
//	else if(dwInCallType == ROUTE_CONNECT_TYPE_REJECT)
//		CVaxServerSIP::AddDirectProxyRejectRoute(sProxyName, ROUTE_CONNECT_TYPE_REJECT, sInCallTo);
//
//
//	return TRUE;
//}
//BOOL CVaxServerExSIP::RemoveDirectProxy(LPCTSTR sProxyName)
//{
//	CRegistry objReg;
//	
//	if(objReg.IsProxyExist(sProxyName))
//		objReg.RemoveProxy(sProxyName);
//
//	CVaxServerSIP::RemoveDirectProxySIP(sProxyName);
//	
//	return TRUE;
//}
//
//void CVaxServerExSIP::ShowQueues(CStringList* pQueueList)
//{
//	CRegistry objReg;
//	objReg.EnumQueue(pQueueList);
//}
//BOOL CVaxServerExSIP::QueueInfo(LPCTSTR sQueueName, CString& sPlayWave, CString& sDigitPlayWave, CStringList* pQueueOPList, CStringList* pPressDigitList, CStringList* pPressDigitUserList)
//{
//	CRegistry objReg;
//	CQueueReg objQueueReg;
//	
//	if(!objReg.GetQueue(sQueueName, &objQueueReg))
//	{
//		OnErrorLog("Queue not found.");
//		return FALSE;
//	}
//	
//	sPlayWave = objQueueReg.m_sPlayWave;
//	sDigitPlayWave = objQueueReg.m_sPressDigitPlayWave;
//		
//	while(!objQueueReg.m_objQueueOPList.IsEmpty())
//		pQueueOPList->AddTail(objQueueReg.m_objQueueOPList.RemoveHead());
//
//	while(!objQueueReg.m_objPressDigitList.IsEmpty())
//		pPressDigitList->AddTail(objQueueReg.m_objPressDigitList.RemoveHead());
//
//	while(!objQueueReg.m_objPressDigitUserList.IsEmpty())
//		pPressDigitUserList->AddTail(objQueueReg.m_objPressDigitUserList.RemoveHead());
//	
//
//	return TRUE;
//}
//BOOL CVaxServerExSIP::AddQueue(LPCTSTR sQueueName, LPCTSTR sPlayWave, LPCTSTR sDigitPlayWave, CStringList* pQueueOPList, CStringList* pPressDigitList, CStringList* pPressDigitUserList, BOOL bEnableDTMF, BOOL& bUpdated)
//{
//	CRegistry objReg;
//	CQueueReg objQueueReg;
//
//	objQueueReg.m_sPlayWave = sPlayWave;
//	objQueueReg.m_sPressDigitPlayWave = sDigitPlayWave;
//	objQueueReg.m_objPressDigitList.AddTail(pPressDigitList);
//	objQueueReg.m_objQueueOPList.AddTail(pQueueOPList);
//	objQueueReg.m_objPressDigitUserList.AddTail(pPressDigitUserList);
//
//	bUpdated = objReg.IsQueueExist(sQueueName);
//
//	if(!objReg.SetQueue(sQueueName, &objQueueReg))
//	{
//		OnErrorLog("Unable to add queue.");
//		return FALSE;
//	}
//
//	CVaxServerSIP::AddQueue(sQueueName, sPlayWave, pQueueOPList, "", bEnableDTMF);
//
//	return TRUE;
//}
//BOOL CVaxServerExSIP::RemoveQueue(LPCTSTR sQueueName)
//{
//	CRegistry objReg;
//	objReg.RemoveQueue(sQueueName);
//
//	CVaxServerSIP::RemoveQueue(sQueueName);
//
//	return TRUE;
//}
//		
//
//BOOL CVaxServerExSIP::SetStealthMusic(LPCTSTR sStealthMusic)
//{
//	CRegistry objReg;
//	
//	if(!objReg.SetStealthListenerMusic(sStealthMusic))
//	{
//		OnErrorLog("Unable to store stealth-listen music file.");
//		return FALSE;
//	}
//
//	BOOL bResult = CVaxServerSIP::LoadMusicStealthListen(sStealthMusic);
//
//	if(!bResult)
//	{
//		OnErrorLog("Unable to load stealth-listen music file.");
//		return FALSE;
//	}
//
//	return TRUE;
//}
//CString CVaxServerExSIP::GetStealthMusic()
//{
//	CRegistry objReg;
//	
//	CString sStealthMusic = objReg.GetStealthListenerMusic();
//
//	return sStealthMusic;
//}
//	
//BOOL CVaxServerExSIP::SetHoldMusic(LPCTSTR sHoldMusic)
//{
//	CRegistry objReg;
//	
//	if(!objReg.SetHoldMusic(sHoldMusic))
//	{
//		OnErrorLog("Unable to store hold music file.");
//		return FALSE;
//	}
//	
//	BOOL bResult = CVaxServerSIP::LoadMusicHold(sHoldMusic);
//	
//	if(!bResult) 
//	{
//		OnErrorLog("Unable to load hold music file.");
//		return FALSE;
//	}
//
//	return bResult;
//}
//CString CVaxServerExSIP::GetHoldMusic()
//{
//	CRegistry objReg;
//	
//	CString sHoldMusic = objReg.GetHoldMusic();
//
//	return sHoldMusic ;
//}
//
//BOOL CVaxServerExSIP::SetDialToneMusic(LPCTSTR sDialToneMusic)
//{
//	//CRegistry objReg;
//	//
//	//if(!objReg.SetDialToneMusic(sDialToneMusic))
//	//{
//	//	OnErrorLog("Unable to store dial tone music file.");
//	//	return FALSE;
//	//}
//
//	//BOOL bResult = CVaxServerCOM::LoadWaveFile(sDialToneMusic);
//
//	//if(!bResult)
//	//{
//	//	OnErrorLog("Unable to load dial tone music file.");
//	//	return FALSE;
//	//}
//
//	return TRUE;
//}
//CString CVaxServerExSIP::GetDialToneMusic()
//{
//	CRegistry objReg;
//	
//	CString sDialTone = objReg.GetDialToneMusic();
//
//	return sDialTone;
//}
//
//BOOL CVaxServerExSIP::GetCOMM(CString& sListenIP, int& nListenPort, CString& sDomainRealm)
//{
//	CRegistry objReg;
//		
//	if(!objReg.GetCOMM(sListenIP, nListenPort, sDomainRealm))
//	{
//		sListenIP = "";
//		nListenPort = 0;
//		sDomainRealm = "";
//	}
//	
//	return TRUE;
//}
//BOOL CVaxServerExSIP::SetCOMM(LPCTSTR sListenIP, int nListenPort, LPCTSTR sDomainRealm)
//{
//	CRegistry objReg;
//	
//	if(!objReg.SetCOMM(sListenIP, nListenPort, sDomainRealm))
//	{
//		OnErrorLog("Unable to save communication settings.");
//		return FALSE;
//	}
//	
//	return TRUE;
//}
//
//void CVaxServerExSIP::LoadServerData(LPCTSTR sHoldPlayWave, LPCTSTR sDialTonePlayWave, LPCTSTR sStealthPlayWave)
//{
//	SetHoldMusic(sHoldPlayWave);
//	SetDialToneMusic(sDialTonePlayWave);
//	SetStealthMusic(sStealthPlayWave);
//
//	LoadLinesToServer();
//	LoadDirectProxiesToServer();
//	LoadQueuesToServer();
//}
//
//void CVaxServerExSIP::LoadLinesToServer()
//{
//	CStringList objLineList;
//	ShowLines(&objLineList);
//
//	CString sDisplayName; CString sUserName; CString sAuthUser; 
//	CString sAuthPwd; CString sDomainRealm; CString sProxySIP; 
//	CString sOutboundProxy; CString sCodecList;
//	CString	sInCallType, sInCallTo;
//
//	CString sLineName;
//
//	DWORD dwInCallType;
//
//	BOOL bRegister, bUpdated = FALSE;
//
//	while(!objLineList.IsEmpty())
//	{
//		sLineName = objLineList.RemoveHead();
//		
//		BOOL bResult = LineInfo(sLineName, sCodecList, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxy, bRegister, dwInCallType, sInCallTo);
//		bResult = AddLine(sLineName, sCodecList, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxy, bRegister, dwInCallType, sInCallTo, bUpdated);
//	}
//}
//void CVaxServerExSIP::LoadDirectProxiesToServer()
//{
//	CStringList objProxyList;
//	ShowDirectProxies(&objProxyList);
//
//	CString sAuthUser, sAuthPwd, sProxyName;
//	CString sDomainRealm; CString sProxySIP; 
//	CString sProxyPort; CString sCodecList;
//	CString	sInCallType; CString sInCallTo;
//
//	DWORD dwInCallType, dwProxyPort;
//
//	BOOL bUpdated = FALSE;
//
//	while(!objProxyList.IsEmpty())
//	{
//		sProxyName = objProxyList.RemoveHead();
//		BOOL bResult = DirectProxyInfo(sProxyName, sCodecList, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, dwProxyPort, dwInCallType, sInCallTo);
//		bResult = AddDirectProxy(sProxyName, sCodecList, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, dwProxyPort, dwInCallType, sInCallTo, bUpdated);
//	}
//}
//void CVaxServerExSIP::LoadQueuesToServer()
//{
//	CStringList objQueueList;
//	ShowQueues(&objQueueList);
//
//	CString sPlayWave, sDigitPlayWave, sQueueName; CStringList objQueueOPList;
//	CStringList objPressDigitList; CStringList objPressDigitUserList;
//
//	BOOL bUpdated = FALSE;
//
//	while(!objQueueList.IsEmpty())
//	{
//		objQueueOPList.RemoveAll();
//		objPressDigitList.RemoveAll();
//		objPressDigitUserList.RemoveAll();
//		
//		sQueueName = objQueueList.RemoveHead();
//		BOOL bResult = QueueInfo(sQueueName, sPlayWave, sDigitPlayWave, &objQueueOPList, &objPressDigitList, &objPressDigitUserList);
//		bResult = AddQueue(sQueueName, sPlayWave, sDigitPlayWave, &objQueueOPList, &objPressDigitList, &objPressDigitUserList, TRUE, bUpdated);
//	}
//}

